18 Commits

Author SHA1 Message Date
v4n 55f382a8e5 Merge pull request #3 from v4n00/dev
Add modpack managing
2025-01-22 21:09:07 +02:00
v4n c1785b5323 feat: added modpack management 2025-01-22 21:07:20 +02:00
v4n 115e8acac3 Merge pull request #2 from v4n00/dev
Install mods in batches
2025-01-17 20:46:05 +02:00
v4n 8b06d76c31 fix: downgrade mod logic 2025-01-17 20:40:03 +02:00
v4n fc7ccc2f7c info: version bump 2025-01-17 17:42:04 +02:00
v4n f763d96797 docs: updated for multiple installs 2025-01-17 17:40:36 +02:00
v4n 83260e9961 feat: install multiple mods at once 2025-01-17 16:59:36 +02:00
v4n 36fc676ce0 Merge branch 'master' into dev 2025-01-17 11:55:58 +02:00
v4n 911a9b86ff compatibility: easier for WSL, read now accepts autocompletion 2025-01-17 11:41:18 +02:00
v4n f9c047078d docs: update, install timeout 2025-01-17 10:06:13 +02:00
v4n c80812476b docs: updated 2025-01-16 17:36:27 +02:00
v4n 740b0edd98 fix: docs for help, backup before upgrading script 2025-01-16 17:08:34 +02:00
v4n cc91661663 code: work on cleaner code 2025-01-16 14:57:43 +02:00
v4n 7b25b235fa Merge pull request #1 from v4n00/dev
Version 0.2.0
2025-01-16 13:53:54 +02:00
v4n a6d0bcfb5f feat: installer treat breaking changes 2025-01-16 13:49:16 +02:00
v4n a46776838a feat: enable/disable functionality 2025-01-16 11:22:19 +02:00
v4n 6bcad99bec feat: changed from zip to tar.gz 2025-01-16 09:40:49 +02:00
v4n 8d6591a19d feat: update functionality testing 2025-01-16 09:24:19 +02:00
5 changed files with 971 additions and 348 deletions
+2 -1
View File
@@ -1,4 +1,5 @@
*
!h2mm
!install.sh
!README.md
!README.md
!version
+155 -120
View File
@@ -1,120 +1,155 @@
# Helldivers 2 Mod Manager CLI
- [Helldivers 2 Mod Manager CLI](#helldivers-2-mod-manager-cli)
- [Installation](#installation)
- [Usage](#usage)
- [Available commands](#available-commands)
- [Basic usage](#basic-usage)
- [Install a mod](#install-a-mod)
- [Uninstall a mod](#uninstall-a-mod)
- [List installed mods](#list-installed-mods)
- [Advanced usage](#advanced-usage)
- [Shortcuts](#shortcuts)
- [Exporting and importing](#exporting-and-importing)
- [Resetting all installed mods](#resetting-all-installed-mods)
- [Database location and details](#database-location-and-details)
- [Contributing](#contributing)
- [Planned features](#planned-features)
Helldivers 2 Mod Manager CLI is a command line interface for managing Helldivers 2 mods. Since there is no mod manager GUI for Helldivers 2 on Linux yet, this small script aims to provide a simple way to manage mods on Linux.
## Installation
To install/update Helldivers 2 Mod Manager CLI run the following command in your terminal:
```bash
sh -c "$(curl -fsSL https://raw.githubusercontent.com/v4n00/h2mm-cli/refs/heads/master/install.sh)"
```
Running this script will require sudo permissions. **DO NOT TRUST** random scripts from the internet. If you want to review the script before running it, check out the mod repository for yourself.
## Usage
The script gets added to `/usr/local/bin/h2mm` and can be used by running `h2mm` in your shell, which will show the help message explaining how to use the script.
```bash
h2mm
```
### Available commands
- `install` - Install a mod with files
- `uninstall` - Uninstall a mod by name
- `list` - List all installed mods
- `export <zip_name>` - Export installed mods to a zip file
- `import <zip_name>` - Import mods from a zip file
- `reset` - Reset all installed mods
- `help` - Display the help message
### Basic usage
#### Install a mod
```bash
h2mm install /path/to/mod.zip
h2mm install /path/to/mod/files
h2mm install -n "Example mod" mod.patch_0 mod.patch_0.stream # -n is mandatory when using files
h2mm install -n "Example mod" mod* # using a wildcard to include all files
```
Important: If the mod has more than 1 variant, you need to install the one you want by unarchiving it separately.
#### Uninstall a mod
```bash
h2mm uninstall "Example mod"
h2mm uninstall -i 1 # uninstall mod with index 1
```
#### List installed mods
```bash
h2mm list
```
## Advanced usage
### Shortcuts
You can use the short form of the commands to save some time. The shortcuts are:
- `i` for `install`
- `u` for `uninstall`
- `l` for `list`
- `ex` for `export`
- `im` for `import`
- `r` for `reset`
### Exporting and importing
You can export all installed mods to a zip file and import mods from the same file. This can be useful for sharing mods with others or for backing up your mods. The zip file will be saved in the current directory.
This will serve as either a backup or a way to have multiple mod setups.
```bash
h2mm export modpack1.zip
h2mm import modpack2.zip
```
### Resetting all installed mods
You can reset all installed mods by running the following command. This will remove all installed mods and the database, in case things go wild.
```bash
h2mm reset
```
### Database location and details
The database is stored in the `Helldivers 2` install directory, under the `data` folder with the name `mods.csv`, where the mods are also installed. The database is a simple CSV file which you can use to manually manage mods if needed, you can mostly use it to rename or reorder mods.
## Contributing
Feel free to contribute to this project by creating a pull request or opening an issue.
## Planned features
- [ ] ! Enable/disable mods
- [ ] !! Easier way to change mod presets
- [ ] !! Change to `.tar.xz` for exporting and importing
- [ ] !!! Find a way to make use of `manifest.json` and simplify installing variants
# Helldivers 2 Mod Manager CLI
Helldivers 2 Mod Manager CLI is a command line interface for managing Helldivers 2 mods. Since there is no Linux mod manager available and I like being a nerd by using CLI tools instead of GUIs, this project was born.
This script is complete, the version will always [remain at 0.x.x](https://0ver.org/)
## Installation and updating
To install/update Helldivers 2 Mod Manager CLI run the following command in your terminal:
```bash
bash -c "$(curl -fsSL https://raw.githubusercontent.com/v4n00/h2mm-cli/refs/heads/master/install.sh)"
```
> [!CAUTION]
> Running this script will require sudo permissions. **DO NOT TRUST** random scripts from the internet. If you want to review the script before running it, check out the mod repository for yourself.
If for some reason, the installation command doesn't work you can:
1. Go to https://raw.githubusercontent.com/v4n00/h2mm-cli/refs/heads/master/install.sh
1. Right click -> Save page as...
1. Go to your downloads folders `cd ~/Downloads`
1. Give the script execution permissions `chmod +x install.sh`
1. Run the script `./install.sh`
## Usage
The script gets added to `/usr/local/bin/h2mm` and can be used by running `h2mm` in your shell, which will show the help message explaining how to use the script.
```bash
h2mm
```
### Available commands
- `install` - Install a mod by the file provided (directory, zip, patch).
- `uninstall` - Uninstall a mod by name (or index).
- `list` - List all installed mods.
- `enable` - Enable a mod by name (or index).
- `disable` - Disable a mod by name (or index).
- `export` - Export installed mods to a zip file.
- `import` - Import mods from a zip file.
- `modpack-create` - Create a modpack from the currently installed mods.
- `modpack-switch` - Switch to a modpack by name (or index).
- `modpack-list` - List all installed modpacks.
- `modpack-delete` - Delete a modpack by name (or index).
- `modpack-overwrite` - Overwrite a modpack by name (or index).
- `modpack-reset` - Reset all installed modpacks.
- `reset` - Reset all installed mods.
- `help` - Display this help message.
### Basic usage
#### Install mod(s)
```bash
h2mm install /path/to/mod.zip
h2mm install /path/to/mod/files
h2mm install /path/to/mod.zip /path/to/mod2.zip /path/to/mod/files
h2mm install -n "Example mod" mod.patch_0 mod.patch_0.stream # -n is mandatory when using files
h2mm install -n "Example mod" mod* # using a wildcard to include all files
```
> [!NOTE]
> If the mod has more than 1 variant, you need to install the one you want by unarchiving it separately and providing the directory.
#### Uninstall a mod
```bash
h2mm uninstall "Example mod"
h2mm uninstall -i 1 # uninstall mod with index 1
```
#### Enable/disable mods
```bash
h2mm enable "Example mod"
h2mm enable -i 1 # enable mod with index 1
h2mm disable "Example mod"
h2mm disable -i 1 # disable mod with index 1
```
#### List installed mods
```bash
h2mm list
```
## Compatibility
The script is developed and tested on Arch Linux, but it should work on other Linux distributions as well. If you encounter any issues, please open an issue on the repository.
Status of platforms:
- Linux :white_check_mark:
- Steam Deck - untested (should work) :grey_question:
- Windows - WSL :white_check_mark:
> The script works on WSL, but you need to specify the path to the Helldivers 2 mods directory manually, to find your Windows partition head to `/mnt/` and from there go to your Helldivers 2 data directory, on a typical install it should be on `/mnt/c/Program\ Files\ \(x86\)/Steam/steamapps/common/Helldivers\ 2/data`. You also need to have `unzip` installed, which can be done by running `sudo apt install unzip`.
## Advanced usage
### Shortcuts
You can use the short form of commands to save some time. The shortcuts are:
- `i` for `install`
- `u` for `uninstall`
- `e` for `enable`
- `d` for `disable`
- `l` for `list`
- `ex` for `export`
- `im` for `import`
- `mc` for `modpack-create`
- `ms` for `modpack-switch`
- `ml` for `modpack-list`
- `md` for `modpack-delete`
- `mo` for `modpack-overwrite`
- `mr` for `modpack-reset`
- `r` for `reset`
### Modpacks support
You can set up modpacks by using the `modpack-*` commands. This allows you to quickly change between a set of mods. For more information, check the help message.
```bash
h2mm modpack-create "Modpack 1"
# install, enable, disable other mods...
h2mm modpack-create "Modpack 2"
h2mm modpack-switch "Modpack 1"
```
### Exporting and importing
You can export all installed mods to a zip file and import mods from the same file. This can be useful for sharing mods with others or for backing up your mods. The archive file (`.tar.gz`) will be saved in the current directory.
```bash
h2mm export modpack1.zip
h2mm import modpack2.zip
```
### Resetting all installed mods
You can reset all installed mods by running the following command. This will remove all installed mods and the database, in case things go wild.
```bash
h2mm reset
```
### Database location and details
The database is stored in the `Helldivers 2` install directory, under the `data` folder with the name `mods.csv`, where the mods are also installed. The database is a simple CSV file which you can use to manually manage mods if needed, you can mostly use it to rename or reorder mods.
## Contributing
Feel free to contribute to this project by creating a pull request or opening an issue.
+721 -223
View File
File diff suppressed because it is too large Load Diff
+92 -4
View File
@@ -2,35 +2,123 @@
set -e
RED='\033[0;31m'
GREEN='\033[0;32m'
ORANGE='\033[0;33m'
NC='\033[0m'
DESTINATION_PATH="/usr/local/bin"
SCRIPT_NAME="h2mm"
REPO_URL="https://raw.githubusercontent.com/v4n00/h2mm-cli/refs/heads/master"
if [ "$(id -u)" -eq 0 ]; then
echo "Run me as normal user, not as root."
exit 1
fi
# --- Main ---
# Warning
echo -e "!!! ${RED}WARNING${NC} !!!"
echo -e "This script will install Helldivers 2 Mod Manager CLI for Linux to $DESTINATION_PATH/$SCRIPT_NAME."
echo -e "Running this script will require sudo permissions. ${RED}DO NOT TRUST${NC} random scripts from the internet."
echo -e "If you want to review the script before running it, check out the mod repository for yourself:"
echo -e "https://github.com/v4n00/h2mm-cli"
echo -e "!!! ${RED}WARNING${NC} !!!"
echo
read -p "Install the script to $DESTINATION_PATH or specify another path (must be included in \$PATH)? (Y/path): " response
# Check if update
# Breaking changes hash table
breaking_changes_patches=(
["2"]='sed -i "s/^\([0-9]\+\),/\1,ENABLED,/" "$1/mods.csv"'
["3"]='sed -i "1 i\\3" "$1/mods.csv"'
)
# Handle breaking changes
if [[ -x "$(command -v $SCRIPT_NAME)" ]]; then
installed_version=$($SCRIPT_NAME --version)
# version 1 show the help message, if the first character is not a 0, store installed version as 0.1.6
[[ ${installed_version:0:1} != "0" ]] && { installed_version="0.1.6"; }
latest_version=$(curl -sS "$REPO_URL"/version)
if [[ "$latest_version" == "$installed_version" ]]; then
echo -e "You are reinstalling version $installed_version."
else
echo -e "You are upgrading from ${ORANGE}$installed_version${NC} -> ${GREEN}$latest_version${NC}."
fi
# split version numbers
installed_major=""
latest_major=""
IFS='.' read -r _1 installed_major _2 <<< "$installed_version"
IFS='.' read -r _1 latest_major _2 <<< "$latest_version"
if [[ $latest_major -gt $installed_major ]]; then
echo -e "${ORANGE}Warning:${NC} Major version upgrade detected."
echo "Check out the changelogs here:"
echo "https://github.com/v4n00/h2mm-cli/releases"
echo "The script will proceed to upgrade ${SCRIPT_NAME} to avoid breaking changes."
# find hd2 path
search_dir="${HOME}"
target_dir="Steam/steamapps/common/Helldivers\ 2/data"
echo "Searching for the Helldivers 2 data directory... (20 seconds timeout)" >&2
game_dir=$(timeout 20 find "$search_dir" -type d -path "*/$target_dir" 2>/dev/null | head -n 1)
if [[ -z "$game_dir" ]]; then
echo "Could not find the Helldivers 2 data directory automatically." >&2
IFS= read -ep "Please enter the path to the Helldivers 2 data directory: " game_dir
if [[ ! -d "$game_dir" ]]; then
echo -e "${RED}Error${NC}: Provided path is not a valid directory." >&2
exit 1
fi
fi
[[ ! -f "$game_dir/mods.csv" ]] && { echo -e "${RED}Error:${NC} mods.csv not found in $game_dir."; exit 1; }
# make backup of mods in case something goes wrong
echo "Creating a backup of mods.csv."
h2mm export
# iterate from installed major number to latest major number
for ((i = installed_major + 1; i <= latest_major; i++)); do
echo -e "Applying breaking changes patch for version $i."
if [[ -n "${breaking_changes_patches[$i]}" ]]; then
eval $(echo "${breaking_changes_patches[$i]}" | sed "s:\$1:$game_dir:")
else
echo "No breaking changes for version $i."
fi
if [[ $? -ne 0 ]]; then
echo -ne "${RED}Error:${NC} Failed to apply breaking changes patch for version $i. Do you want to continue? (Y/n): "
read -er response
[[ "$response" != "y" && "$response" != "Y" && -n "$response" ]] && { echo "Exiting. Uninstall the script first the retry the install script."; exit 1; }
else
echo -e "Breaking changes patch for version ${ORANGE}$i${NC} applied ${GREEN}successfully${NC}."
fi
done
fi
echo
fi
# Install
IFS= read -ep "Install the script to $DESTINATION_PATH or specify another path (must be included in \$PATH)? (Y/path): " response
if [[ "$response" != "y" && "$response" != "Y" && -n "$response" ]]; then
DESTINATION_PATH=$(eval echo "$response")
DESTINATION_PATH="$response"
if [[ ! -d "$DESTINATION_PATH" ]]; then
echo -e "${RED}Error:${NC} Path $DESTINATION_PATH does not exist. Exiting..."
echo -e "${RED}Error:${NC} Path $DESTINATION_PATH does not exist."
exit 1
fi
fi
echo "Installing $SCRIPT_NAME to $DESTINATION_PATH."
sudo curl https://raw.githubusercontent.com/v4n00/h2mm-cli/refs/heads/master/h2mm --output "$DESTINATION_PATH/$SCRIPT_NAME"
sudo curl "$REPO_URL"/h2mm --output "$DESTINATION_PATH/$SCRIPT_NAME"
sudo chmod +x "$DESTINATION_PATH/$SCRIPT_NAME"
if [[ ! -x "$(command -v $SCRIPT_NAME)" ]]; then
+1
View File
@@ -0,0 +1 @@
0.3.0